/*
 * Copyright 2011 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.ssg.tools.jsonxml.impl;

import java.util.List;
import java.util.Map;

/**
 *
 * @author ssg
 */
public class DumpFormat extends StructureFormat {

    public DumpFormat() {
    }

    public DumpFormat(boolean indented) {
        super(indented);
    }

    @Override
    public String startElement(String name, Object object) {
        return getQuoteName() + name + getQuoteName() + " [" + ((object != null) ? object.getClass().getSimpleName() : "null") + "] ";
    }

    @Override
    public String startValue(Object object) {
        return getObjectTypeString(object);
    }

    @Override
    public String startList(List object) {
        return getObjectTypeString(object) + super.startList(object);
    }

    @Override
    public String startMap(Map object) {
        return getObjectTypeString(object) + super.startMap(object);
    }

    String getObjectTypeString(Object object) {
        if (getStack().size() > 1 && getStack().get(getStack().size() - 2) instanceof List) {
            return "[" + ((object != null) ? object.getClass().getSimpleName() : "null") + "] ";
        } else {
            return "";
        }
    }
}
