/*
 * Copyright 2011 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.ssg.tools.jsonxml.impl;

import java.util.List;
import java.util.Map;

/**
 * Keeps in XML info on listed items by adding attribute json="list".
 *
 * @author ssg
 */
public class XMLFormatForJSON1 extends XMLFormat {

    public XMLFormatForJSON1() {
        super();
    }

    public XMLFormatForJSON1(boolean indented) {
        super(indented);
    }

    @Override
    public String getElementExtendedAttributes(String name, Object object) {
        String extensions = "";
        if (object instanceof List) {
            extensions = " json=\"list\"";
        } else if (object instanceof Map && name != null && ((Map) object).get(name) instanceof List) {
            extensions = " json=\"list\"";
        }
        return extensions;
    }
}
