/*
 * Copyright 2011 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.ssg.tools.jsonxml.utils;

import java.io.IOException;

/**
 * Used to describe or wrap errors during parsing/formatting.
 * 
 * @author ssg
 */
public class StructureProcessingException extends IOException {

    /**
     * @return the _details
     */
    public StructureErrorInfo getDetails() {
        return _details;
    }
    private StructureErrorInfo _details;

    public StructureProcessingException(Throwable cause) {
        super(cause);
    }

    public StructureProcessingException(String message, Throwable cause) {
        super(message, cause);
    }

    public StructureProcessingException(String message) {
        super(message);
    }

    public StructureProcessingException() {
    }

    public StructureProcessingException(String message, Throwable cause, StructureErrorInfo details) {
        super(message, cause);
        _details = details;
    }

    @Override
    public String toString() {
        return super.toString() + ((getDetails() != null) ? " " + getDetails() : "");
    }
}
